VendorSearch = LibStub("AceAddon-3.0"):NewAddon("VendorSearch", "AceConsole-3.0", "AceEvent-3.0")



-- Author : Adriweb

-- Changelog :

-- 	Version 1.6 :
--	 -Corrected bug of the "lower" function, where no keyword was entered [yet].

--	Version 1.5 :
--   -Added the Opacity Hiding / Full Hiding Options
--   -Added some Help






Keyword=""
KeywordType="name"
money=GetMoney()
VendorSearch.OpacityHiding = true
VendorSearch.FullHiding = false

local options = {
    name = "VendorSearch",
    handler = VendorSearch,
    type = "group",
    args = {

 	    about = {
		     type = "group",
		     name = "About",
		     args = {
		     		about = {
		     			type = "description",
		     			name = "Made by Adriweb, 2009.   Please Donate if you enjoy it :D",
		 			},
		 	},
		},
 	    help = {
		     type = "group",
		     name = "Help",
		     args = {
		     		help = {
		     			type = "description",
		     			name = "By default, the addon is set with these settings : \n     Graphical Mode \n     Full Hiding Mode \n     Type of search : by Name \n\nYou can change these settings either in the Options Tab. \n \n After that, just type in your keywords in the second text box.",
		 			},
		 	},
		},
		Options = {
	     	type = "group",
	     	name = "Options",
    	 	desc = "Configure VendorSearch",
			args = {
     			Verbose = {
	     			type = "toggle",
	     			name = "Textual mode",
    	 			desc = "Toggle the Textual mode",
					set = "ToggleVerbose",
					get = "IsVerbose",
     			},
     			OpacityHiding = {
	     			type = "toggle",
	     			name = "Opacity Hiding mode",
    	 			desc = "Toggle the hiding mode to opacity Change",
					set = "ToggleOpacityHiding",
					get = "IsOpacityHiding",
     			},
     			FullHiding = {
	     			type = "toggle",
	     			name = "Full Hiding mode",
    	 			desc = "Toggle the hiding mode to opacity Change",
					set = "ToggleFullHiding",
					get = "IsFullHiding",
     			},
     		},
     	},
	},
}


function VendorSearch:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("VendorSearch", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("VendorSearch", "VendorSearch")
    self:RegisterChatCommand("vendorsearch", "ChatCommand")
 	self:RegisterChatCommand("vs", "ChatCommand")
end

function VendorSearch:OnEnable()
    -- Called when the addon is enabled
    DEFAULT_CHAT_FRAME:AddMessage("VendorSearch v1.5 : Loaded")
    self:RegisterEvent("MERCHANT_SHOW")
end


function VendorSearch:OnDisable()
    -- Called when the addon is disabled
end

totalitems = GetMerchantNumItems();


--------------
--SearchBox:--
--------------

-- local searchboxtype = CreateFrame("EditBox","MerchantFrameSearchTypeFrame",MerchantFrame,"InputBoxTemplate")
-- searchboxtype:SetFrameStrata("HIGH")
-- searchboxtype:SetAutoFocus(nil)
-- searchboxtype:SetWidth(80)
-- searchboxtype:SetHeight(26)
-- searchboxtype:SetPoint("TOP",-65,-45)
-- searchboxtype:SetText("name")
-- searchboxtype:SetScript("OnEnterPressed", function(self)
-- 	KeywordType = searchboxtype:GetText()
-- searchboxtype:ClearFocus()
-- VendorSearch:Search(Keyword)
-- end)


local searchbox = CreateFrame("EditBox","MerchantFrameSearchFrame",MerchantFrame,"InputBoxTemplate")
searchbox:SetFrameStrata("HIGH")
searchbox:SetAutoFocus(nil)
searchbox:SetWidth(160)
searchbox:SetHeight(26)
searchbox:SetPoint("TOP",10,-45) -- next version : 60 and -45
searchbox:SetText("")
searchbox:SetScript("OnEnterPressed", function(self)
	Keyword = searchbox:GetText()
	searchbox:ClearFocus()
	VendorSearch:Search(Keyword)
	end)
searchbox:SetScript("OnTextChanged", function(self)
Keyword = searchbox:GetText()
VendorSearch:Search(Keyword)
end)


--------------
--Functions:--
--------------

function VendorSearch:IsVerbose(info)
    return self.Verbose
end

function VendorSearch:ToggleVerbose(info, value)
    self.Verbose = value
end

function VendorSearch:IsOpacityHiding(info)
    return VendorSearch.OpacityHiding
end

function VendorSearch:ToggleOpacityHiding(info, value)
    VendorSearch.OpacityHiding = value
    VendorSearch.FullHiding = not value
end

function VendorSearch:IsFullHiding(info)
    return VendorSearch.FullHiding
end

function VendorSearch:ToggleFullHiding(info, value)
    VendorSearch.FullHiding = value
    VendorSearch.OpacityHiding = not value
end


function VendorSearch:MERCHANT_SHOW()
 VendorSearch:MERCHANT_LIST()
	for i=1,totalitems do
		name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
		link = GetMerchantItemLink(i);
		itemname = name
		itemprice = price
		if self.Verbose == true then
 			DEFAULT_CHAT_FRAME:AddMessage("Item " .. i .. " : " .. link .. " - " .. price .. " copper");
		end
 	end
	if Keyword then
		VendorSearch:Search(Keyword)
	end
end



function VendorSearch:Search(Keyword)

found = 0
links = ""

if Keyword then

 for i=1,totalitems do
 	name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(i);
	   link = GetMerchantItemLink(i);
 	   itemname = name
 	   itemprice = price
 	   itemusable = isUsable
 	    		
 	f = getglobal("MerchantItem" .. i)

 	if KeywordType == "name" and string.find(string.lower(itemname), string.lower(Keyword)) then
 		montrer();
  			found = found + 1
 			if links == "" then
 				links = links .. link .. " - " .. price .. "c"
 			else
 				links = links .. " , \n" .. link .. " - " .. price .. "c"
 			end
 			if i == totalitems then
				if self.Verbose == true then
					DEFAULT_CHAT_FRAME:AddMessage(" ")
					DEFAULT_CHAT_FRAME:AddMessage("Results of search : Item(s) found from keyword \"" .. Keyword .. "\" : " .. found)
					DEFAULT_CHAT_FRAME:AddMessage(links)
					DEFAULT_CHAT_FRAME:AddMessage(" ")
				end
			end
 	else
		cacher();
	end

 end --for
 
 
end -- if keyword

end --function



function cacher()
	if VendorSearch.FullHiding == true then
	    f:Hide();
	else
		f:SetAlpha(0.15);
	end	
end

function montrer()
	f:Show();
	f:SetAlpha(1);
end


function VendorSearch:MERCHANT_LIST()
	totalitems = GetMerchantNumItems();
	if self.Verbose == true then
		DEFAULT_CHAT_FRAME:AddMessage("Number of items : " .. totalitems);
	end
end


--------------
--Ace Stuff:--
--------------


function VendorSearch:ChatCommand(input)
   if (not input or input:trim() == "") then
        --InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
        LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(VendorSearch, "vs", "VendorSearch", input)
    end
end

function VendorSearch:ShowOptions()
    LibStub("AceConfigDialog-3.0"):Open("VendorSearch")
end